// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_error_codes.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "../xobf/x_common.h"

// error codes
enum {
	X_ERR_SUCCESS,

	XL_VIRT_UNSUPPORTED_OPERAND = 1,
	XL_ERR_RELOC_FINDING_BAD_OP,
	XL_ERR_ASGN_VM_TO_BLOCKS_NO_DATA,
	XL_ERR_PARSE_CONTEXT_DATA,
	XL_ERR_PROCESS_CONTEXT,
	XL_ERR_PROCESS_CONTEXT_THREAD,
	XL_ERR_PROCESS_CONTEXT_WAIT,
	XL_ERR_PROCESS_CONTEXT_GET_EXIT_CODE,
	XL_ERR_PROCESS_CONTEXT_REPLY_NOT_ENOUGH_DATA,
	XL_ERR_PROCESS_CONTEXT_REPLY_BAD_PROTOCOL,
	XL_ERR_PROCESS_CONTEXT_REPLY_TOO_MUCH_DATA,
	XL_ERR_PROCESS_CONTEXT_GEN_DATA_BAD_DATA_LENGTH,
	XL_ERR_ASSEMBLE_NEW_SECTION_NO_DATA,
	XL_ERR_SPLIT_BLOCKS_BAD_NUM,
	XL_ERR_VIRTUALIZE_BLOCK_PART_NO_INSTRUCTIONS,
	XL_ERR_VIRTUALIZE_BLOCK_PART_RELOC_NOT_HANDLED,
	XL_ERR_REGISTER_DATA_BAD_TYPE,
	XL_ERR_GET_DATA_BAD_ID,
	XL_ERR_GET_DATA_VA_BAD_ID,
	XL_ERR_GET_DATA_LEN_BAD_ID,
	XL_ERR_ASSEMBLE_VM_CODE_NO_INS,
	XL_ERR_ENCODE_MNEMONIC_BAD_MN,
	XL_ERR_ENCODE_REGISTER_BAD_MN,
	XL_ERR_ENCODE_REGISTER_BAD_REG,
	XL_ERR_ENCODE_BYTE_BAD_MN,
	XL_ERR_ENCODE_WORD_BAD_MN,
	XL_ERR_ENCODE_DWORD_BAD_MN,
	XL_ERR_ENCODE_OP_BAD_ID,
	XL_ERR_ASSEMBLE_VM_CODE_BAD_OP,
	XL_ERR_ASSEMBLE_VM_CODE_BAD_VARIABLE_MNEMONIC,
	XL_ERR_ASSEMBLE_VM_CODE_NO_BYTECODE,
	XL_ERR_ASSEMBLE_VM_CODE_BAD_SIZE,
	XL_ERR_GET_DATA_RVA_BAD_ID,
	XL_ERR_VM_REGISTER_HANDLING_ERROR,
	XL_ERR_VA_HIGHEST_BIT,
	XL_ERR_LOAD_X86_REG_NOT_REG,
	XL_ERR_LOAD_X86_MEM_NOT_MEM,
	XL_ERR_LOAD_X86_MEM_BAD_REG_SIZE,
	XL_ERR_LOAD_X86_IMM_BAD_TYPE,
	XL_ERR_GET_X86_MEM_SIZE_NOT_MEM,
	XL_ERR_GET_X86_MEM_SIZE_NO_SIZE,
	XL_ERR_X86_REG_TO_VM_HANDLING_ERROR,
	XL_ERR_VM_RESOLVE_REFERENCES_UNRESOLVED,
	XL_ERR_IS_ADDR_IN_BLOCK_CANNOT_LINK,
	XL_ERR_CANT_GET_LOCAL_DIR,
	X_ERR_GEN_FUNCTIONS_NO_FUNCS,
	X_ERR_GEN_FUNCTIONS_EMPTY_FUNC,
	X_ERR_DISASM_BLOCK_BAD_LENGTH,
	X_ERR_ADD_OPERANDS_UNSUPPORTED_OP,
	X_ERR_CHECK_INS_INONE,
	X_ERR_CHECK_INS_UNSUPPORTED,
	X_ERR_INS_NOT_ANALYZED,
	X_ERR_ANALYZE_RELOCS_PARSING_ERROR,
	X_ERR_ANALYZE_RELOCS_NOT_FOUND,
	X_ERR_ANALYZE_RELOCS_NOT_HANDLED,
	X_ERR_INIT_SHUFFLE_PASS_BAD_PASS,
	X_ERR_VER_FUNC_RVA_NOT_CORRECTED,
	X_ERR_PARSE_TEMP_RELOCS_BAD_RELOC_INFO,
	X_ERR_EMIT_BP_NO_DIS,
	X_ERR_EMIT_BP_BAD_BPJ,
	X_ERR_UDIS_REG_TO_ASMJIT_UNK_REG,
	X_ERR_MUT_UNSUPPORTED_OPERAND,
	X_ERR_MUT_REL_START_HANDLING_ERROR,
	X_ERR_ADDR_TO_LABEL_CANNOT_LINK,
	X_ERR_ADDR_IN_BLOCK_CANNOT_LINK,
	X_ERR_EMIT_BP_UNSUPPORTED_INSTRUCTION,
	X_ERR_EMIT_BP_RELOC_NOT_HANDLED,
	X_ERR_GET_FUNC_RVA_BAD_ID,
	X_ERR_GET_FUNC_VA_BAD_ID,
	X_ERR_PROCESS_CONTEXT_REINIT_ASSEMBLER,
	X_ERR_CONSTRUCT_CTX_REPLY_BAD_TYPE,
	X_ERR_GET_VM_INS_INFO_BAD_INS,
	X_ERR_GET_VM_OP_LEN_BAD_OP,
	X_ERR_GET_VN_INS_INFO_BAD_INS,
	X_ERR_MEM_OP_TO_ASMJIT_NOT_MEM,
	X_ERR_MEM_OP_TO_ASMJIT_UNSUPPORTED_OP,
	X_ERR_PARSE_CTX_VM_ARCH_TOO_NO_VM,
	X_ERR_PARSE_CTX_VM_ARCH_TOO_MANY_VM,
	X_ERR_GET_FUNC_BAD_ID,
	X_ERR_GET_RANDOM_REG_NOT_AVAILABLE,
	X_ERR_ABORT_IF_ALL_REGS_NOT_FREE,
	X_ERR_NEED_REGISTER_ALREADY_NEEDED,
	X_ERR_RELEASE_REGISTER_NOT_NEEDED,
	X_ERR_IS_REGISTER_NEEDED_BAD_REG,
	X_ERR_ALLOC_REGISTER_NOT_AVAILABLE,
	X_ERR_INIT_VM_STACK_BAD_ID,
	X_ERR_VM_STACK_BAD_ID,
	X_ERR_EXEC_CODE_IN_BUFFER_BAD_LENGTH,
	X_ERR_GET_OP_OFFSET_BAD_OP_ID,
	X_ERR_GET_OP_SIZE_BAD_OP_ID,
	X_ERR_FETCH_MEM_BAD_SRC_SIZE,
	X_ERR_RESTORE_REGISTER_STATE_INVALID_VA,
	X_ERR_GEN_IMM_OBF_BAD_STEP,
	X_ERR_MOV_IMM_BAD_STEP,
	X_ERR_SPLIT_BLOCKS_ALLOWED_FORCED,
	X_ERR_SVG_BAD_INIT_LIMITS,
	X_ERR_SVG_FOPEN_IN_FAILED,
	X_ERR_SVG_FOPEN_OUT_FAILED,
	X_ERR_SVG_TOO_LARGE_INPUT_FILE,
	X_ERR_SVG_FREAD_INPUT_FAILED,
	X_ERR_SVG_INPUT_BAD_INPUT_LEN,
	X_ERR_SVG_CANT_DECODE,
	X_ERR_SVG_CANT_ENCODE,
	X_ERR_EMPTY_CTX_REPLY,
	X_ERR_FWRITE_OUT_FAILED,
	XR_ERR_CANT_LOADLIB_CURL,
	XR_ERR_CURL_POST_FAILED,
	XR_ERR_REPLY_NO_DATA,
	XR_ERR_INVALID_REPLY,
	XR_ERR_B64_ENCODE_NULL,
	XR_ERR_NO_CTX_DATA,
	XR_ERR_CANT_DECODE_CTX_REPLY,
	X_ERR_TOO_MANY_VMS,
	X_ERR_TOO_MANY_BLOCKS,

	// total number of error codes
	XL_ERR_TOTAL
};
