// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: xl_block_parts.h 641 2015-02-21 01:46:27Z tzubcic $

#pragma once

// common includes
#include "../xobf/x_common.h"

// local headers
#include "xl_disassembly.h"

typedef struct xl_bp_s {
	// first instruction
	xl_disasm_t			*dis;

	// number of instructions in this block
	unsigned			num_instructions;

	// part id for referencing after shuffle
	unsigned			part_id;

	// link parts together
	unsigned			prev_id;
	unsigned			next_id;
	struct xl_bp_s		*prev;
	struct xl_bp_s		*next;
} xl_bp_t;

// split all blocks into smaller blocks
void xl_split_blocks(void);

// shuffle all blocks
void xl_shuffle_block_parts(void);

// link code block parts
void xl_update_block_part_links(void);

// process all block parts
void xl_process_block_parts(void);

// virtualize a part
void xl_virtualize_block_part(xl_bp_t *);

// emit fake instruction id as a reference to start of a real instruction
void xl_emit_fake_ins_with_id(struct xl_vm_s *, xl_disasm_t *);
