// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: xl_context.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "../xobf/x_common.h"

// construct the whole block of data
void xl_construct_context_data(void);

// construct individual blocks of data
void xl_construct_context_vm_architectures(void);
void xl_construct_context_block_information(void);
void xl_construct_context_imports(void);
void xl_construct_context_data_addresses(void);

// write individual values
void xl_ctx_write_byte(UINT8, bool obfuscate = true);
void xl_ctx_write_word(UINT16, bool obfuscate = true);
void xl_ctx_write_dword(UINT32, bool obfuscate = true);
void xl_ctx_write_qword(UINT64, bool obfuscate = true);
void xl_ctx_write_bool(bool, bool obfuscate = true);
