// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: xl_context_reply.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "../xobf/x_common.h"

// initialize context from buffer
void xl_initialize_context_reply(void *, unsigned);

// parse the whole block of data
void xl_parse_context_reply_data(void);

// parse specific types of reply data
void xl_parse_context_reply_gen_data(void);
void xl_parse_context_reply_error_message(void);

// individual parsers for gen data
void xl_parse_context_reply_gen_new_data(void);
void xl_parse_context_reply_relocations(void);
void xl_parse_context_reply_exec_bytecode(void);
void xl_parse_context_reply_vmi_handlers(void);

// read individual values
void xl_ctxr_read_byte(UINT8 *, bool deobfuscate = true);
void xl_ctxr_read_word(UINT16 *, bool deobfuscate = true);
void xl_ctxr_read_dword(UINT32 *, bool deobfuscate = true);
void xl_ctxr_read_qword(UINT64 *, bool deobfuscate = true);
void xl_ctxr_read_bool(bool *, bool deobfuscate = true);

