// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: xl_data.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "../xobf/x_common.h"

// random data length
#define XL_RAND_DATA_LENGTH_MIN		128
#define XL_RAND_DATA_LENGTH_MAX		1024

enum {
	// data types
	XL_DT_INITIALIZED,
	XL_DT_RANDOM,

	// total number of data types
	XL_DT_TOTAL
};

enum {
	XL_DATA_RELOC_INFO,
	XL_DATA_SIGNATURE,
	XL_DATA_BASE_DIFFERENCE,
	XL_DATA_CALL_DISPATCH_RVA,

	// total number of common data allocations
	XL_DATA_TOTAL
};

typedef struct {
	// data type
	unsigned		type;

	// length and data
	unsigned		length;

	// virtual address
	UINT32			va;
	UINT32			rva;

	// new section offset
	UINT32			offset;
} xl_data_block_t;

typedef struct {
	// addresses
	UINT32					current_va;
	UINT32					current_len;

	// information about all data blocks
	vector<xl_data_block_t>	data_blocks;
} xl_data_t;

// initialize data management
void xl_init_data_management(void);

// register common data
void xl_register_common_data(void);

// register new data
unsigned xl_register_data(unsigned, unsigned);

// get pointer to data buffer
void *xl_get_data(unsigned);

// get virtual address of a data block
UINT32 xl_get_data_va(unsigned);
UINT32 xl_get_data_rva(unsigned);

// get length of a data block
unsigned xl_get_data_length(unsigned);

