// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: xl_operands.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "../xobf/x_common.h"

// forward declaration
struct xl_disasm_s;

typedef struct {
	// [mem] values
	unsigned		base;
	unsigned		index;
	UINT8			scale;
	UINT32			offset;

	// referenced memory size
	UINT32			size;
} xl_op_mem_t;

typedef union {
	unsigned		reg;
	UINT32			val;
	xl_op_mem_t		mem;
} xl_op_data_t;

typedef struct {
	// disassembly owner
	struct xl_disasm_s	*dis;

	// operand type
	UINT32				type;

	// operand data
	xl_op_data_t		data;

	// is this operand relocateable
	bool				is_reloc;

	// relocation handled
	bool				reloc_handled;

	// reloc offset to instruction RVA
	UINT32				reloc_offset;
} xl_op_t;

// parse operands
void xl_add_operands(struct xl_disasm_s *);
