// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: xl_pe_bliss.cpp 652 2015-02-24 21:15:39Z tzubcic $

#include "xl_local.h"

UINT32 xl_rva_to_offset(UINT32 rva)
{
	return xl.pe_input->rva_to_file_offset(rva);
}

UINT32 xl_rva_to_va(UINT32 rva)
{
	return xl.pe_input->rva_to_va_32(rva);
}

UINT32 xl_va_to_rva(UINT32 va)
{
	return xl.pe_input->va_to_rva((uint32_t) va);
}

UINT32 xl_va_to_offset(UINT32 va)
{
	return xl_rva_to_offset(xl_va_to_rva(va));
}

UINT32 xl_offset_to_rva(UINT32 offset)
{
	return xl.pe_input->file_offset_to_rva(offset);
}

UINT32 xl_offset_to_va(UINT32 offset)
{
	return xl_rva_to_va(xl_offset_to_rva(offset));
}

UINT32 xl_ptr_to_va(UINT8 *ptr)
{
	return xl_offset_to_va(xl_ptr_to_offset(ptr));
}

UINT32 xl_ptr_to_rva(UINT8 *ptr)
{
	return xl_offset_to_rva(xl_ptr_to_offset(ptr));
}

UINT32 xl_ptr_to_offset(UINT8 *ptr)
{
	return (ptr - &xl.raw_file[0]);
}

UINT8 *xl_va_to_ptr(UINT32 va)
{
	return &xl.raw_file[xl_va_to_offset(va)];
}

UINT8 *xl_rva_to_ptr(UINT32 rva)
{
	return &xl.raw_file[xl_rva_to_offset(rva)];
}

UINT8 *xl_offset_to_ptr(UINT32 offset)
{
	return &xl.raw_file[offset];
}

void xl_assemble_new_section(void)
{
	string		data;

	if (!xl.nsc_data.size()) {
		xl_code_gen_error(XL_ERR_ASSEMBLE_NEW_SECTION_NO_DATA);
	}

	printf("[+] Assembling new section at 0x%08X (%u bytes)\n", xl.nsc_va, xl.nsc_data.size());

	for (unsigned i = 0; i < xl.nsc_data.size(); i++) {
		data += xl.nsc_data[i];
	}

	xl.new_section->set_raw_data(data);
	xl.pe_input->set_section_virtual_size(*xl.new_section, xl.new_section->get_raw_data().length());
}

void xl_update_code_section(void)
{
	string			data;

	printf("[+] Updating code section\n");

	for (unsigned i = 0; i < xl.code_size; i++) {
		data += xl.code_data[i];
	}


	xl.code_section->set_raw_data(data);
}
