// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: xl_x86.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "../xobf/x_common.h"

// EFLAGS - bit numbers
#define X_X86F_CARRY_BIT		0
#define X_X86F_PARITY_BIT		2
#define X_X86F_ADJUST_BIT		4
#define X_X86F_ZERO_BIT			6
#define X_X86F_SIGN_BIT			7
#define X_X86F_DIRECTION_BIT	10
#define X_X86F_OVERFLOW_BIT		11

// EFLAGS - masks
#define X_X86F_CARRY			(1 << X_X86F_CARRY_BIT)
#define X_X86F_PARITY			(1 << X_X86F_PARITY_BIT)
#define X_X86F_ADJUST			(1 << X_X86F_ADJUST_BIT)
#define X_X86F_ZERO				(1 << X_X86F_ZERO_BIT)
#define X_X86F_SIGN				(1 << X_X86F_SIGN_BIT)
#define X_X86F_DIRECTION		(1 << X_X86F_DIRECTION_BIT)
#define X_X86F_OVERFLOW			(1 << X_X86F_OVERFLOW_BIT)
