// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_asmjit.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

// local headers
#include "x_operands.h"
#include "x_udis86.h"

// AsmJit library - http://code.google.com/p/asmjit/
#include "../libs/asmjit/asmjit.h"

// local headers
#include "x_operands.h"
#include "x_udis86.h"

// namespaces
using namespace asmjit;
using namespace asmjit::x86;

// convert from one library to another
const X86GpReg *x_udis_reg_to_asmjit_reg(unsigned);
X86Mem x_mem_op_to_asmjit(x_op_t *);

// allocate and bind labels
Label *x_new_label(void);
void x_bind_label(Label *);

// emit memory
UINT32 x_write_memory(UINT8 *, UINT32);

// emit random memory
void x_emit_random_bytes(void);
