// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_asmjit_hook.cpp 657 2015-02-25 11:42:33Z tzubcic $

#include "x_local.h"

// assembler
#define A			(*xg.code_gen)

void x_asmjit_emit_hook(void *self)
{
	X86Assembler		*ASM;
	static unsigned		no_junk_cnt = 0;

	ASM = (X86Assembler *) self;

	if (ASM == xg.code_gen && xg.ctx->generating_functions) {
		if (xg.ctx->hs.inside_hook) {
			x_add_register_state();
			return;
		} else {
			if (!xg.ctx->hs.inside_hook) {
				xg.ctx->hs.inside_hook = true;

				if (xg.ctx->hs.junk_enabled) {
					if ((x_rand_range(0, 2) == 1) || (no_junk_cnt >= 3)) {
						x_emit_junk_instruction();

						no_junk_cnt = 0;
					} else {
						no_junk_cnt++;
					}
				} else {
					no_junk_cnt++;
				}
			}

			xg.ctx->hs.inside_hook = false;
		}

		x_add_register_state();
	}
}

void x_set_junk_state(bool state)
{
	xg.ctx->hs.junk_enabled = state;
}
