// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_context_reply.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

// construct the context reply
void x_construct_context_reply(unsigned);

// construct the whole block of data
void x_construct_context_reply_gen_data(void);

// construct individual blocks of data
void x_construct_context_reply_relocations(void);
void x_construct_context_reply_exec_bytecode(void);
void x_construct_context_reply_vmi_handlers(void);

// write individual values
void x_ctxr_write_byte(UINT8, bool obfuscate = true);
void x_ctxr_write_word(UINT16, bool obfuscate = true);
void x_ctxr_write_dword(UINT32, bool obfuscate = true);
void x_ctxr_write_qword(UINT64, bool obfuscate = true);
void x_ctxr_write_bool(bool);
void x_ctxr_write_buf(void *, unsigned, bool obfuscate = true);
