// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_generic_functions.cpp 657 2015-02-25 11:42:33Z tzubcic $

#include "x_local.h"

// assembler
#define A			(*xg.code_gen)

static bool old_junk_state;

XINLINE void x_func_reloc_add(UINT32 val)
{
	if (xg.ctx->has_relocs) {
		old_junk_state = xg.ctx->hs.junk_enabled;

		x_set_junk_state(false);
		x_add_reloc_value(val);
	}
}

XINLINE void x_func_reloc_end(void)
{
	if (xg.ctx->has_relocs) {
		x_end_gen_reloc_value();
		x_set_junk_state(old_junk_state);
	}
}

void x_register_generic_functions(void)
{
	// entry point
	xg.ctx->generic_functions[X_FUNC_ENTRY_POINT] = x_register_func(x_gen_function_entry_point, NULL);

	// exit process
	xg.ctx->generic_functions[X_FUNC_EXIT_PROCCESS] = x_register_func(x_gen_function_exit_process, NULL);
}

void x_gen_function_entry_point(void *data)
{
	A.nop();
}

void x_gen_function_exit_process(void *data)
{
	x_x86_reg_t		*r1;

	x_code_shuffling(false);
	x_set_junk_state(false);

	r1 = x_get_random_register(false, false, &A);

	A.mov(*(r1->reg), 1);
	A.push(*(r1->reg));
	x_func_reloc_add(xg.ctx->imports[X_IMP_EXITPROCESS]);
	A.mov(*(r1->reg), xg.ctx->imports[X_IMP_EXITPROCESS]);
	x_func_reloc_end();
	A.mov(*(r1->reg), dword_ptr(*(r1->reg)));
	A.call(*(r1->reg));

	x_release_register(r1, &A);

	x_set_junk_state(true);
	x_code_shuffling(true);
}

void x_gen_call_import(UINT32 imp)
{
	UINT32			addr;
	x_x86_reg_t		*tmp;

	old_junk_state = xg.ctx->hs.junk_enabled;
	x_set_junk_state(false);

	addr = xg.ctx->imports[imp];

	tmp = x_get_random_register(true, false, &A);

	x_func_reloc_add(addr);
	A.mov(*(tmp->reg), addr);
	x_func_reloc_end();

	A.mov(*(tmp->reg), dword_ptr(*(tmp->reg)));
	A.call(*(tmp->reg));

	x_release_register(tmp, &A);

	x_set_junk_state(old_junk_state);
}

void x_gen_read_dword(UINT32 addr, x_x86_reg_t *dst)
{
	old_junk_state = xg.ctx->hs.junk_enabled;
	x_set_junk_state(false);

	x_func_reloc_add(addr);
	A.mov(*(dst->reg), addr);
	x_func_reloc_end();
	A.mov(*(dst->reg), dword_ptr(*(dst->reg)));

	x_set_junk_state(old_junk_state);
}
