// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_instructions.cpp 657 2015-02-25 11:42:33Z tzubcic $

#include "x_local.h"

#define X_DEF_INS_CHECK(name)	void x_check_ ## name(struct x_disasm_s *dis) \
								{

#define X_END_INS_CHECK				dis->is_analyzed = true; \
								}

// ----------------------------------
// push*
// ----------------------------------
X_DEF_INS_CHECK(push)
	dis->needs_esp = true;
	dis->mods_esp = true;
	dis->mods_eip = false;
	dis->needs_flags = false;
	dis->mods_flags = false;
X_END_INS_CHECK

X_DEF_INS_CHECK(pushad)
	dis->needs_esp = true;
	dis->mods_esp = true;
	dis->mods_eip = false;
	dis->needs_flags = false;
	dis->mods_flags = false;
X_END_INS_CHECK

X_DEF_INS_CHECK(pushfd)
	dis->needs_esp = true;
	dis->mods_esp = true;
	dis->mods_eip = false;
	dis->needs_flags = true;
	dis->mods_flags = false;
X_END_INS_CHECK

// ----------------------------------
// pop*
// ----------------------------------
X_DEF_INS_CHECK(pop)
	dis->needs_esp = true;
	dis->mods_esp = true;
	dis->mods_eip = false;
	dis->needs_flags = false;
	dis->mods_flags = false;
X_END_INS_CHECK

X_DEF_INS_CHECK(popad)
	dis->needs_esp = true;
	dis->mods_esp = true;
	dis->mods_eip = false;
	dis->needs_flags = false;
	dis->mods_flags = false;
X_END_INS_CHECK

X_DEF_INS_CHECK(popfd)
	dis->needs_esp = true;
	dis->mods_esp = true;
	dis->mods_eip = false;
	dis->needs_flags = false;
	dis->mods_flags = true;
X_END_INS_CHECK

// ----------------------------------
// mov*
// ----------------------------------
X_DEF_INS_CHECK(mov)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(movzx)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(movsx)
	
X_END_INS_CHECK

// ----------------------------------
// arithmetic
// ----------------------------------
X_DEF_INS_CHECK(add)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(sub)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(mul)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(imul)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(div)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(idiv)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(inc)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(dec)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(adc)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(neg)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(sbb)
	
X_END_INS_CHECK

// ----------------------------------
// logical
// ----------------------------------
X_DEF_INS_CHECK(or)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(xor)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(and)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(not)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(shl)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(shr)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(ror)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(rol)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(shld)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(shrd)
	
X_END_INS_CHECK

// ----------------------------------
// comparisons
// ----------------------------------
X_DEF_INS_CHECK(cmp)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(test)
	
X_END_INS_CHECK

// ----------------------------------
// jumps
// ----------------------------------
X_DEF_INS_CHECK(jmp)
	dis->needs_esp = true;
	dis->mods_esp = false;
	dis->mods_eip = true;
	dis->needs_flags = true;
	dis->mods_flags = false;
X_END_INS_CHECK

X_DEF_INS_CHECK(jcc)
	
X_END_INS_CHECK

// ----------------------------------
// procedures
// ----------------------------------
X_DEF_INS_CHECK(call)
	
X_END_INS_CHECK

X_DEF_INS_CHECK(ret)
	
X_END_INS_CHECK

// ----------------------------------
// other
// ----------------------------------
X_DEF_INS_CHECK(nop)
	dis->needs_esp = false;
	dis->mods_esp = false;
	dis->mods_eip = false;
	dis->needs_flags = false;
	dis->mods_flags = false;
X_END_INS_CHECK

X_DEF_INS_CHECK(lea)

X_END_INS_CHECK

X_DEF_INS_CHECK(xchg)

X_END_INS_CHECK

X_DEF_INS_CHECK(stc)

X_END_INS_CHECK

X_DEF_INS_CHECK(cld)

X_END_INS_CHECK

X_DEF_INS_CHECK(clc)

X_END_INS_CHECK

X_DEF_INS_CHECK(std)

X_END_INS_CHECK

X_DEF_INS_CHECK(cmc)

X_END_INS_CHECK

X_DEF_INS_CHECK(bt)

X_END_INS_CHECK
