// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_instructions.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

// forward declaration
struct x_disasm_s;

#define X_DECL_INS_CHECK(name)	void x_check_ ## name(struct x_disasm_s *)

// push*
X_DECL_INS_CHECK(push);
X_DECL_INS_CHECK(pushad);
X_DECL_INS_CHECK(pushfd);

// pop*
X_DECL_INS_CHECK(pop);
X_DECL_INS_CHECK(popad);
X_DECL_INS_CHECK(popfd);

// mov*
X_DECL_INS_CHECK(mov);
X_DECL_INS_CHECK(movzx);
X_DECL_INS_CHECK(movsx);

// arithmetic
X_DECL_INS_CHECK(add);
X_DECL_INS_CHECK(sub);
X_DECL_INS_CHECK(mul);
X_DECL_INS_CHECK(imul);
X_DECL_INS_CHECK(div);
X_DECL_INS_CHECK(idiv);
X_DECL_INS_CHECK(inc);
X_DECL_INS_CHECK(dec);
X_DECL_INS_CHECK(adc);
X_DECL_INS_CHECK(neg);
X_DECL_INS_CHECK(sbb);

// logical
X_DECL_INS_CHECK(or);
X_DECL_INS_CHECK(xor);
X_DECL_INS_CHECK(and);
X_DECL_INS_CHECK(not);
X_DECL_INS_CHECK(shl);
X_DECL_INS_CHECK(shr);
X_DECL_INS_CHECK(ror);
X_DECL_INS_CHECK(rol);
X_DECL_INS_CHECK(shld);
X_DECL_INS_CHECK(shrd);

// comparisons
X_DECL_INS_CHECK(cmp);
X_DECL_INS_CHECK(test);

// jumps
X_DECL_INS_CHECK(jmp);
X_DECL_INS_CHECK(jcc);

// procedures
X_DECL_INS_CHECK(call);
X_DECL_INS_CHECK(ret);

// other
X_DECL_INS_CHECK(nop);
X_DECL_INS_CHECK(lea);
X_DECL_INS_CHECK(xchg);
X_DECL_INS_CHECK(stc);
X_DECL_INS_CHECK(cld);
X_DECL_INS_CHECK(clc);
X_DECL_INS_CHECK(std);
X_DECL_INS_CHECK(cmc);
X_DECL_INS_CHECK(bt);
