// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_junk.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

typedef bool (*x_junk_function_t)(void);

typedef struct {
	unsigned						emit_count;
	vector<x_junk_function_t>		funcs;
} x_junk_functions_t;

// register junk instructions
void x_register_junk_instructions(void);

// add a junk instruction
void x_add_junk_instruction(x_junk_function_t);

// emit a random junk instruction
void x_emit_junk_instruction(void);

// random junk instructions
bool x_random_ins_1(void);

// register junk operations
void x_register_junk_operations(void);

// add a junk operation
void x_add_junk_operation(x_junk_function_t);

// emit a random junk operation
void x_emit_junk_operation(void);

// random junk operations
bool x_random_op_1(void);
