// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_local.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

// shared headers
#include "../x_local/x_error_codes.h"
#include "x_vm_shared.h"

// local headers
#include "x_interface.h"
#include "x_functions.h"
#include "x_context.h"
#include "x_vm.h"
#include "x_asmjit.h"
#include "x_generic_functions.h"
#include "x_error.h"
#include "x_blocks.h"
#include "x_disassembly.h"
#include "x_operands.h"
#include "x_udis86.h"
#include "x_instructions.h"
#include "x_relocations.h"
#include "x_mutate.h"
#include "x_vm_functions.h"
#include "x_block_parts.h"
#include "x_registers.h"
#include "x_call_dispatcher.h"
#include "x_context_reply.h"
#include "x_data.h"
#include "x_binary_emulation.h"
#include "x_vm_stack.h"
#include "x_x86_emul.h"
#include "x_junk.h"
#include "x_vm_misc.h"
#include "x_asmjit_hook.h"
#include "x_imm_obf.h"

typedef struct {
	// context data information
	void			*ctx_data;
	unsigned		ctx_data_len;
	unsigned		ctx_data_offset;

	// input file context
	x_ctx_t			*ctx;

	// context data
	vector<UINT8>	ctx_reply_data;

	// code assembler
	StaticRuntime	*code_gen_runtime;
	X86Assembler	*code_gen;

	// temp assembler
	StaticRuntime	*temp_runtime;
	X86Assembler	*temp_gen;
} x_global_t;

// global object
extern x_global_t xg;
