// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_mutate.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

// local headers
#include "x_disassembly.h"

#define X_DECL_INS_MUTATE(name)		void x_mutate_ ## name(x_disasm_t *)

// push*
X_DECL_INS_MUTATE(push);
X_DECL_INS_MUTATE(pushad);
X_DECL_INS_MUTATE(pushfd);

// pop*
X_DECL_INS_MUTATE(pop);
X_DECL_INS_MUTATE(popad);
X_DECL_INS_MUTATE(popfd);

// mov*
X_DECL_INS_MUTATE(mov);
X_DECL_INS_MUTATE(movzx);
X_DECL_INS_MUTATE(movsx);

// arithmetic
X_DECL_INS_MUTATE(add);
X_DECL_INS_MUTATE(sub);
X_DECL_INS_MUTATE(mul);
X_DECL_INS_MUTATE(imul);
X_DECL_INS_MUTATE(div);
X_DECL_INS_MUTATE(idiv);
X_DECL_INS_MUTATE(inc);
X_DECL_INS_MUTATE(dec);
X_DECL_INS_MUTATE(adc);
X_DECL_INS_MUTATE(neg);
X_DECL_INS_MUTATE(sbb);

// logical
X_DECL_INS_MUTATE(or);
X_DECL_INS_MUTATE(xor);
X_DECL_INS_MUTATE(and);
X_DECL_INS_MUTATE(not);
X_DECL_INS_MUTATE(shl);
X_DECL_INS_MUTATE(shr);
X_DECL_INS_MUTATE(ror);
X_DECL_INS_MUTATE(rol);
X_DECL_INS_MUTATE(shld);
X_DECL_INS_MUTATE(shrd);

// comparisons
X_DECL_INS_MUTATE(cmp);
X_DECL_INS_MUTATE(test);

// jumps
X_DECL_INS_MUTATE(jmp);
X_DECL_INS_MUTATE(jo);
X_DECL_INS_MUTATE(jno);
X_DECL_INS_MUTATE(jb);
X_DECL_INS_MUTATE(jae);
X_DECL_INS_MUTATE(jz);
X_DECL_INS_MUTATE(jnz);
X_DECL_INS_MUTATE(jbe);
X_DECL_INS_MUTATE(ja);
X_DECL_INS_MUTATE(js);
X_DECL_INS_MUTATE(jns);
X_DECL_INS_MUTATE(jp);
X_DECL_INS_MUTATE(jnp);
X_DECL_INS_MUTATE(jl);
X_DECL_INS_MUTATE(jge);
X_DECL_INS_MUTATE(jle);
X_DECL_INS_MUTATE(jg);

// procedures
X_DECL_INS_MUTATE(call);
X_DECL_INS_MUTATE(ret);

// other
X_DECL_INS_MUTATE(nop);
X_DECL_INS_MUTATE(lea);
X_DECL_INS_MUTATE(xchg);
X_DECL_INS_MUTATE(stc);
X_DECL_INS_MUTATE(cld);
X_DECL_INS_MUTATE(clc);
X_DECL_INS_MUTATE(std);
X_DECL_INS_MUTATE(cmc);
X_DECL_INS_MUTATE(bt);
