// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_operands.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

// forward declaration
struct x_disasm_s;

typedef struct {
	// [mem] values
	unsigned		base;
	unsigned		index;
	UINT8			scale;
	UINT32			offset;

	// referenced memory size
	UINT32			size;
} x_op_mem_t;

typedef union {
	unsigned		reg;
	UINT32			val;
	x_op_mem_t		mem;
} x_op_data_t;

typedef struct {
	// disassembly owner
	struct x_disasm_s	*dis;

	// operand type
	UINT32				type;

	// operand data
	x_op_data_t		data;

	// is this operand relocateable
	bool				is_reloc;

	// relocation handled
	bool				reloc_handled;

	// reloc offset to instruction RVA
	UINT32				reloc_offset;
} x_op_t;

// parse operands
void x_add_operands(struct x_disasm_s *);

// is esp in operands
bool x_is_esp_in_operand(x_op_t *);
