// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_relocations.cpp 657 2015-02-25 11:42:33Z tzubcic $

#include "x_local.h"

// assembler
#define A							(*xg.code_gen)

void x_add_reloc_value(UINT32 value)
{
	x_reloc_info_t		*ri;
	x_reloc_t			r;

	ri = &xg.ctx->gen_reloc;

	r.value = value;
	r.addr_start = A.getCodeSize();
	r.found = false;

	ri->relocs.push_back(r);
}

void x_end_gen_reloc_value(void)
{
	x_reloc_info_t		*ri;

	ri = &xg.ctx->gen_reloc;

	ri->relocs[ri->relocs.size() - 1].addr_end = A.getCodeSize();
}

void x_clear_relocation_info(void)
{
	xg.ctx->gen_reloc.relocs.clear();
}

void x_add_final_reloc(UINT32 va)
{
	if (xg.ctx->has_relocs) {
		xg.ctx->final_relocs.push_back(va);
	}
}

void x_parse_temp_relocations(void)
{
	x_reloc_info_t		*ri;
	x_reloc_t			*r;
	UINT8				*base_ptr;
	UINT8				*search_ptr;
	unsigned			search_len;
	UINT32				reloc_va;

	if (xg.ctx->has_relocs) {
		ri = &xg.ctx->gen_reloc;

		base_ptr = &xg.ctx->gen_data[0];

		for (unsigned i = 0; i < ri->relocs.size(); i++) {
			r = &ri->relocs[i];

			if ((search_len = r->addr_end - r->addr_start) < 5) {
				x_exit_thread(X_ERR_PARSE_TEMP_RELOCS_BAD_RELOC_INFO);
			}

			for (unsigned j = 0; j <= (search_len - 4); j++) {
				search_ptr = base_ptr + r->addr_start + j;

				if (*(UINT32 *) search_ptr == r->value) {
					reloc_va = xg.ctx->nsc_va + xg.ctx->nsc_data_size + r->addr_start + j;
					x_add_final_reloc(reloc_va);
				}
			}
		}
	}
}
