// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_relocations.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

typedef struct {
	// value flagged for relocation
	UINT32		value;

	// address range where value should be located
	UINT32		addr_start;
	UINT32		addr_end;

	// whether a relocation has been found
	bool		found;
} x_reloc_t;

typedef struct {
	vector<x_reloc_t>		relocs;
} x_reloc_info_t;

// init relocation search
void x_add_reloc_value(UINT32);

// end relocation search
void x_end_gen_reloc_value(void);

// clear relocation info
void x_clear_relocation_info(void);

// add a final relocation
void x_add_final_reloc(UINT32);

// add temporary relocations to final reloc table
void x_parse_temp_relocations(void);
