// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_unix.cpp 652 2015-02-24 21:15:39Z tzubcic $

// common includes
#include "x_common.h"

// compile this file only on unix
#ifdef __linux__

#define rdtsc(low,high) __asm__ __volatile__("rdtsc" : "=a" (low), "=d" (high))

void x_seed_rand(void)
{
	union {
		uint64_t		q;
		struct {
			uint32_t	dw[2];
		} d;
	} u;

	rdtsc(u.d.dw[0], u.d.dw[1]);

	// timestamp counter
	x_rand_next = u.d.dw[0] ^ u.d.dw[1];
}

void x_exit_thread(unsigned code)
{
	// serverside generator does not use threads
	exit(code);
}

#endif
