// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_vm_stack.h 652 2015-02-24 21:15:39Z tzubcic $

#pragma once

// common includes
#include "x_common.h"

// shared headers
#include "x_vm_shared.h"

enum {
	X_VM_STACK_CONTEXT,
	X_VM_STACK_EIP_BACKUP,
	X_VM_STACK_DECRYPT_BUFF,
	X_VM_STACK_BASE_DIFF,
	X_VM_STACK_RAND,
	X_VM_STACK_INS_EXEC,
	X_VM_STACK_ORIG,
	X_VM_STACK_ENC_KEY,

	// total number of stack entries (except esp)
	X_VM_STACK_TOTAL
};

typedef struct {
	unsigned		order[X_VM_STACK_TOTAL];
	UINT32			offset[X_VM_STACK_TOTAL];
	UINT32			esp_offset;
} x_vm_stack_t;

// forward declaration
struct x_vm_s;

// initialize stack for a virtual machine
void x_init_vm_stack(struct x_vm_s *);

// get stack offset
UINT32 x_vm_stack_offset(struct x_vm_s *, unsigned);
