// x86obf - a code virtualizer/obfuscator for 32bit PE files
// Copyright (c) 2015 Tomislav Zubcic - chaplja.blogspot.com / x86obf@gmail.com
// $Id: x_windows.cpp 657 2015-02-25 11:42:33Z tzubcic $

// common includes
#include "x_common.h"

// compile this file only on windows
#ifdef WIN32

void x_seed_rand(void)
{
	union {
		uint64_t		q;
		struct {
			uint32_t	dw[2];
		} d;
	} u;
	DWORD			tmp;
	char			path[MAX_PATH];

	u.q = __rdtsc();

	//x_rand_next = tsc;
	
	// timestamp counter
	x_rand_next = u.d.dw[0] ^ u.d.dw[1];

	// process id
	tmp = GetCurrentProcessId();
	x_rand_next = x_crc32(x_rand_next, &tmp, sizeof(tmp), 0);

	// thread id
	tmp = GetCurrentThreadId();
	x_rand_next = x_crc32(x_rand_next, &tmp, sizeof(tmp), 0);
	// current tick count since start
	tmp = GetTickCount();
	x_rand_next = x_crc32(x_rand_next, &tmp, sizeof(tmp), 0);

	// current path
	tmp = GetCurrentDirectoryA(sizeof(path), path);
	x_rand_next = x_crc32(x_rand_next, &tmp, sizeof(tmp), 0);

	if (tmp && (tmp < (sizeof(tmp) - 2))) {
		x_rand_next = x_crc32(x_rand_next, path, tmp, 0);
	}
}

void x_exit_thread(unsigned code)
{
	ExitThread(code);
}

#endif
